package com.cqut.stack.bn.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.cqut.stack.bn.pojo.dto.resourceTrade.GetResourceTransactionsDTO;
import com.cqut.stack.bn.pojo.entity.ResourceTransaction;
import com.cqut.stack.bn.dao.ResourceTransactionMapper;
import com.cqut.stack.bn.service.ResourceTransactionService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.util.List;

@Service
public class ResourceTransactionServiceImpl extends ServiceImpl<ResourceTransactionMapper, ResourceTransaction> implements ResourceTransactionService {

    @Override
    public List<ResourceTransaction> getResourceTransactionList() {
        LambdaQueryWrapper<ResourceTransaction> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.eq(ResourceTransaction::getTransactionDate, LocalDate.now());
        PageHelper.startPage(1, 10);
        return this.list(queryWrapper);
    }

    @Override
    public List<ResourceTransaction> getResourceTransactionsList(GetResourceTransactionsDTO dto) {
        LambdaQueryWrapper<ResourceTransaction> qw = Wrappers.lambdaQuery();
        qw.ge(ObjectUtil.isNotEmpty(dto.getStartDate()), ResourceTransaction::getTransactionDate, dto.getStartDate())
                .le(ObjectUtil.isNotEmpty(dto.getEndDate()), ResourceTransaction::getTransactionDate, dto.getEndDate());
        PageHelper.startPage(dto.getPageNum(), dto.getPageSize());
        return this.list(qw);
    }
}
